import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.List;
import java.util.SortedMap;

import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingWorker;


public class Bworker extends SwingWorker<Object, Object>{
	private File file;
	private SortedMap<String, Book> m;
	private StringBuffer sb;
	private JList list;
	private JFrame frame;
	private JDialog dialog;
	public Bworker(File file, SortedMap<String, Book> m, JList list, JFrame frame){
		this.file = file;
		this.m = m;
		this.list = list;
		this.sb = new StringBuffer();
		this.frame = frame;
		frame.getGlassPane().addMouseListener(new MouseAdapter(){
			public void mousePressed(MouseEvent e){
				e.consume();
			}
		});
		frame.getGlassPane().setVisible(true);

		dialog = new JDialog(frame, "データ取得及びXMLファイルの作成");
		JPanel pane = (JPanel)dialog.getContentPane();
		dialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		JLabel panel = new JLabel("データの取得及びXMLファイルの作成中です...");
		pane.add(panel);
		dialog.pack();
		dialog.setResizable(false);
		dialog.setVisible(true);
	}
	@Override
	public Object doInBackground(){
		XMLCreator xml_c = new XMLCreator(file, m, sb);
		xml_c.createXML();
		return null;
	}
	@Override
	public void done(){
		dialog.setVisible(false);
		frame.getGlassPane().setVisible(false);
		MouseListener[] listeners = frame.getGlassPane().getMouseListeners();
		for(MouseListener listener : listeners){
			frame.getGlassPane().removeMouseListener(listener);
		}
		if(sb.length() != 0){
			File efile = new File("../error.log");
			try{
				PrintWriter writer =
					new PrintWriter(
						new BufferedWriter(
								new OutputStreamWriter(
										new FileOutputStream(efile), "utf-8")));
				int offset = 0;
				int offset2 = 0;

				while((offset2 = sb.indexOf("・", offset)) != -1){
					writer.println(sb.substring(offset, offset2));
					offset = offset2+1;
				}
				writer.close();
				JOptionPane.showMessageDialog(frame, "エラーが発生しました。"
													+ System.getProperty("line.separator")
													+"情報の一部が表示されていない可能性があります。"
													+ System.getProperty("line.separator")
													+"詳細はerror.logに書き出しました。"
													+System.getProperty("line.separator")
													+"ファイルを添付して製作者にご連絡ください。",
													"エラー報告", JOptionPane.ERROR_MESSAGE);
			}catch(IOException ioe){
				JOptionPane.showMessageDialog(frame, ioe, "エラー書き込みエラー", JOptionPane.ERROR_MESSAGE);
			}
		}
		DefaultListModel model = (DefaultListModel)list.getModel();
		model.clear();
		for(String temp : m.keySet()){
			model.addElement(temp);
		}
	}
}
