import java.io.*;
import java.net.*;
import java.util.*;

public class COMFInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public COMFInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"utf-8"));
			String line;
			String author = null;
			String title = null;
			String label = null;
			String price = null;
			String date = null;
			int flag = 0;
			int offset = 0;
			int offset2 = 0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if((flag == 0)
						&& (line.indexOf("comic_title\">") != -1)){
					offset =line.indexOf(">");
					offset2 = line.lastIndexOf("</p>");
					title = line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 1)
						&& (line.indexOf("author\">") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("</p>");
					author = line.substring(offset+1, offset2).replaceAll("／", "・").replaceAll("：", ":");
					flag++;
				}
				else if((flag == 2)
						&& (line.indexOf("data\">") != -1)){
					offset = line.indexOf("/");
					offset2 = line.indexOf("発売");
					date = line.substring(offset+1, offset2);

					offset = line.indexOf("判 ", offset2);
					offset2 = line.indexOf("円", offset);
					price = line.substring(offset+2, offset2);
					flag++;
				}
				else if((flag == 3)
						&& (line.indexOf("icon\">") != -1)){
					if(line.indexOf("icon_1.gif") != -1){
						label = "MFコミックス";
					}
					else if(line.indexOf("icon_3.gif") != -1){
						label = "MFR";
					}
					else{
						label = "-";
					}

					map.put(title, new Book(title, "メディアファクトリー", label, author, date, price));
					flag = 0;
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}