import java.io.*;
import java.net.*;
import java.util.*;

import javax.swing.JOptionPane;

public class KADCInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;

	public KADCInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"euc_jp"));
			String line;
			String author = null;
			String price = null;
			String title = null;
			String date = null;
			int flag = 0;
			int offset = 0;
			int offset2 =0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<!-- /footer -->") != -1){
					break;
				}
				if((flag >= 0)
						&& ((offset = line.indexOf("/image/ma_sb-comic11.gif")) != -1)){
					flag++;
				}
				else if((flag == 1)
						&& ((offset = line.indexOf("<font class=\"j12\"")) != -1)){
					offset = line.indexOf("<b>", offset);
					offset2 = line.lastIndexOf("</b>");
					title = line.substring(offset+3, offset2);
					title = title.trim();
					flag++;
				}
				else if((flag == 2)
						&& (line.indexOf("<font class=\"j12\"") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<br>", line.lastIndexOf("</font>"));
					if(offset2 >= 0){
						author = line.substring(offset+1, offset2);
					}
					else{
						author = "";
					}
					author = author.replaceAll("<br>", "・");
					author = author.replaceAll("著:", "著者:");
					author = author.replaceAll("作:", "原作:");
					author = author.replaceAll("キャラ原:", "キャラクター原案:");
					author = author.replaceAll("画:", "作画:");
					author = author.replaceAll("キャラデザ:", "キャラクターデザイン:");
					author = author.replaceAll("監:", "監修:");
					author = author.replaceAll("脚:", "脚本:");
					author = author.replaceAll("案:", "原案:");
					author = author.replaceAll("シ:", "シナリオ:");
					flag++;
				}
				else if((flag == 3)
						&& (line.indexOf("発売日") != -1)){
					offset = line.indexOf("年");
					offset2 = line.indexOf("月");
					date = line.substring(offset+1, offset2);
					date = date.trim();

					offset = line.lastIndexOf("日");
					String temp = line.substring(offset2+1, offset);
					temp = temp.trim();

					date = date + "/" + temp;
					flag++;
				}
				else if((flag == 4)
						&& (line.indexOf("定価") != -1)){
					offset = line.indexOf("：");
					offset2 = line.lastIndexOf("円");
					price = line.substring(offset+1, offset2);

					map.put(title, new Book(title, "角川書店", author, date, price));
					flag = 1;
				}

			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}