import java.io.*;
import java.net.*;
import java.util.*;

public class KADInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public KADInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"euc_jp"));
			String line;
			String author = null;
			String label = null;
			String price = null;
			String title = null;
			String date = null;
			String[] labelArray = {"角川スニーカー文庫",
									"角川ルビー文庫",
									"角川ビーンズ文庫",
									"角川mini文庫",
									"富士見ドラゴンブック",
									"富士見ファンタジア文庫",
									"富士見ミステリー文庫"};
			int flag = 0;
			int offset = 0;
			int offset2 =0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<!-- /footer -->") != -1){
					break;
				}
				if((flag >= 0)
						&& ((offset = line.indexOf("/image/ma_sb-bunko")) != -1)){
					flag = 0;
					offset2 = line.indexOf(".gif", offset);
					label = line.substring(offset+"/image/ma_sb-bunko".length(), offset2);
					switch(Integer.parseInt(label)){
						case 16:
							label = labelArray[0];
							flag++;
							break;
						case 17:
							label = labelArray[1];
							flag++;
							break;
						case 18:
							label = labelArray[2];
							flag++;
							break;
						case 19:
							label = labelArray[3];
							flag++;
							break;
						case 20:
							label = labelArray[4];
							flag++;
							break;
						case 21:
							label = labelArray[5];
							flag++;
							break;
						case 22:
							label = labelArray[6];
							flag++;
							break;
						default: break;
					}
				}
				else if((flag == 1)
						&& ((offset = line.indexOf("<font class=\"j12\"")) != -1)){
					offset = line.indexOf("<b>", offset);
					offset2 = line.lastIndexOf("</b>");
					title = line.substring(offset+3, offset2);
					title = title.trim();
					flag++;
				}
				else if((flag == 2)
						&& (line.indexOf("<font class=\"j12\"") != -1)){
					offset = line.indexOf(">");
					offset2 = line.lastIndexOf("<br>", line.lastIndexOf("</font>"));
					author = line.substring(offset+1, offset2);
					author = author.replaceAll("<br>", "・");
					author = author.replaceAll("著:", "原作:");
					author = author.replaceAll("イ:", "イラスト:");
					flag++;
				}
				else if((flag == 3)
						&& (line.indexOf("発売日") != -1)){
					offset = line.indexOf("年");
					offset2 = line.indexOf("月");
					date = line.substring(offset+1, offset2);
					date = date.trim();

					offset = line.lastIndexOf("日");
					String temp = line.substring(offset2+1, offset);
					temp = temp.trim();

					date = date + "/" + temp;
					flag++;
				}
				else if((flag == 4)
						&& (line.indexOf("定価") != -1)){
					offset = line.indexOf("：");
					offset2 = line.lastIndexOf("円");
					price = line.substring(offset+1, offset2);

					map.put(title, new Book(title, "角川書店", label, author, date, price));
					flag = 1;
				}

			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}