import java.io.*;
import java.net.*;
import java.util.*;

public class KDNCInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public KDNCInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb = sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"shift_jis"));
			String line;
			String author = null;
			String title = null;
			String label = "";
			String price = null;
			String date = null;
			String t = "";
			String[] labelArray = {"イブニングＫＣ",
					"モーニングＫＣ",
					"少年マガジンＫＣ",
					"月刊マガジンＫＣ",
					"ＫＣデラックス",
					"プレミアムＫＣ",
					"講談社プラチナコミックス",
					"別冊フレンドＫＣ",
					"ＢＥ　ＬＯＶＥ　ＫＣ",
					"ワイドＫＣ",
					"ＫＩＳＳＫＣ",
					"デザートＫＣ",
					"ヤンマガＫＣスペシャル",
					"シリウスＫＣ",
					"アフタヌーンＫＣ",
					"ＫＣｘ（ＡＲＩＡ）",
					"ＫＣｘ（ＩＴＡＮ）",
					"なかよしＫＣ",
					"ライバルＫＣ"};
			int flag = 0;
			int offset = 0;
			int offset2 =0;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if((flag >= 0) && (line.indexOf("<!--Footer　フッター 開始-->") != -1)){
					break;
				}
				if((flag == 0)
						&& (line.indexOf("<font size=\"2\"><b>") != -1)){
					for(int i = 0; i < labelArray.length; i++){
						if(line.indexOf(labelArray[i]) != -1){
							label = labelArray[i];
							flag++;
						}
					}
				}
				else if((flag == 1) && (line.indexOf("<font size=\"3\">") != -1)){
					offset = line.indexOf(">", line.indexOf("<a href="));
					offset2 = line.indexOf("</a>", offset);
					title = line.substring(offset+1, offset2);
					flag++;
				}
				else if((flag == 2) && (line.indexOf("<font size=\"2\">") != -1)){
					flag++;
				}
				else if((flag == 3)){
					flag++;
				}
				else if((flag == 4) && (line.indexOf("</font>") != -1)){
					author = t;
					t = "";
					flag += 2;
				}
				else if((flag == 4) && ((offset = line.indexOf("<b>")) != -1)){
					if(!t.equals("")){
						t = t.concat("・");
					}

					t = t.concat(line.substring(0, offset).trim());

					offset = line.indexOf(">", line.indexOf("<a href="));
					offset2 = line.indexOf("</a>", offset);

					t = t.concat(line.substring(offset+1, offset2));
					flag++;
				}
				else if(flag == 5){
					flag = 3;
				}
				else if((flag == 6)
						&& (line.indexOf("<font size=\"2\">") != -1)){
					offset = line.indexOf("年", line.indexOf("<b>"));
					offset2 = line.indexOf("日", offset);

					date = line.substring(offset+1, offset2);
					date = date.replaceFirst("月", "/");
					flag++;
				}
				else if((flag == 7)
						&& (line.indexOf("<font size=\"2\">") != -1)){
					flag++;
				}
				else if((flag == 8)
						&& (line.indexOf("<font size=\"2\">") != -1)){
					offset = line.indexOf("<b>");
					offset2 = line.indexOf("円", offset);

					price = line.substring(offset+3, offset2);

					map.put(title, new Book(title, "講談社", label, author, date, price));
					flag = 0;
				}
			}
			reader.close();
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}