import java.util.SortedMap;

import javax.swing.JList;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class MySelectionListener implements ListSelectionListener {
	private JTextField titleField,
						authorField,
						publisherField,
						labelField,
						priceField,
						dateField;
	private SortedMap<String, Book> m;
	public MySelectionListener(JTextField titleField,
								JTextField authorField,
								JTextField publisherField,
								JTextField labelField,
								JTextField priceField,
								JTextField dateField,
								SortedMap<String, Book> m){
		this.titleField = titleField;
		this.authorField = authorField;
		this.publisherField = publisherField;
		this.labelField = labelField;
		this.priceField = priceField;
		this.dateField = dateField;
		this.m = m;
	}
	@Override
	public void valueChanged(ListSelectionEvent e) {
		if(e.getValueIsAdjusting() == false){
			JList list = (JList)e.getSource();
			String key = (String)list.getSelectedValue();
			if(key == null) return;
			Book book = m.get(key);
			titleField.setText(book.getTitle());
			authorField.setText(book.getAuthor());
			publisherField.setText(book.getPublisher());
			labelField.setText(book.getLabel());
			priceField.setText(book.getPrice());
			dateField.setText(book.getDate());
		}
	}

}
