import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.File;
import java.util.Collections;
import java.util.SortedMap;
import java.util.TreeMap;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.text.*;
public class NBooksGetterMain extends JFrame{

	public static void main(String[] args){
		NBooksGetterMain frame = new NBooksGetterMain("新刊情報げったー");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(700, 500);
		frame.setVisible(true);
	}

	public NBooksGetterMain(String title){
		super(title);
		File file = new File("../data.xml");
		SortedMap<String, Book> m = Collections.synchronizedSortedMap(new TreeMap<String, Book>());

		JPanel pane = (JPanel)this.getContentPane();

		JPanel InfoPanel = new JPanel();
		InfoPanel.setLayout(new BoxLayout(InfoPanel, BoxLayout.Y_AXIS));
		JTextField titleField = new JTextField(30);
		titleField.setEditable(false);
		titleField.setBorder(new TitledBorder("タイトル"));
		InfoPanel.add(titleField);
		JTextField authorField = new JTextField(30);
		authorField.setEditable(false);
		authorField.setBorder(new TitledBorder("著者など"));
		InfoPanel.add(authorField);
		JTextField publisherField = new JTextField(30);
		publisherField.setEditable(false);
		publisherField.setBorder(new TitledBorder("出版社"));
		InfoPanel.add(publisherField);
		JTextField labelField = new JTextField(30);
		labelField.setEditable(false);
		labelField.setBorder(new TitledBorder("レーベル"));
		InfoPanel.add(labelField);
		JTextField priceField = new JTextField(30);
		priceField.setEditable(false);
		priceField.setBorder(new TitledBorder("価格"));
		InfoPanel.add(priceField);
		JTextField dateField = new JTextField(30);
		dateField.setEditable(false);
		dateField.setBorder(new TitledBorder("発売日"));
		InfoPanel.add(dateField);
		pane.add(InfoPanel, BorderLayout.EAST);

		DefaultListModel model = new DefaultListModel();
		JList list = new JList(model){
			@Override public int getNextMatch(String prefix, int startIndex, Position.Bias bias) {
		    return -1;
		  }};
		  list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		  list.addListSelectionListener(new MySelectionListener(titleField,
				  												authorField,
				  												publisherField,
				  												labelField,
				  												priceField,
				  												dateField, m));
		JScrollPane sc = new JScrollPane(list);
		sc.setBorder(new TitledBorder("タイトル一覧"));
		pane.add(sc, BorderLayout.CENTER);

		if(!file.exists()){
			Bworker worker = new Bworker(file, m, list, (JFrame)this);
			worker.execute();
		}else{
			DataGetterFromXML dgfx = new DataGetterFromXML(file, m);
			dgfx.GetData();
			for(String temp : m.keySet()){
				model.addElement(temp);
			}
		}

		JPanel searchPanel = new JPanel();
		searchPanel.setLayout(new BoxLayout(searchPanel, BoxLayout.X_AXIS));
		String[] choice = {"タイトルから",
							"著者などから",
							"出版社から",
							"レーベル名から"};
		JComboBox searchCombo = new JComboBox(choice);
		JTextField searchField = new JTextField();
		searchField.addActionListener(new SearchActionListener(searchField, list, m, searchCombo));

		JButton newDataButton = new JButton("最新情報を取得");
		newDataButton.addActionListener(new BWorkerActionListener(file, m, list, (JFrame)this));
		JButton allTitleButton = new JButton("一覧");
		allTitleButton.addActionListener(new AllTitleActionListener(list, m));
		JButton searchButton = new JButton("検索");
		searchButton.addActionListener(new SearchActionListener(searchField, list, m, searchCombo));
		searchPanel.add(searchField);
		searchPanel.add(searchButton);
		searchPanel.add(searchCombo);
		searchPanel.add(allTitleButton);
		searchPanel.add(newDataButton);
		pane.add(searchPanel, BorderLayout.NORTH);
	}
}
