import java.io.*;
import java.net.*;
import java.util.*;

public class SYOGKCInfogetter implements Runnable{
	private URL url;
	private SortedMap<String, Book> map;
	private StringBuffer sb;
	public SYOGKCInfogetter(URL url, SortedMap<String, Book> map, StringBuffer sb){
		this.url = url;
		this.map = map;
		this.sb =sb;
	}

	public void run(){
		try{
			URLConnection connection =url.openConnection();
			connection.connect();
			BufferedReader reader =
				new BufferedReader(
						new InputStreamReader(
								connection.getInputStream(),
								"shift_jis"));
			String line;
			int offset = 0;
			int offset2 = 0;
			String fig = null;
			while((line = reader.readLine()) != null){
					//クラスごとに独自の実装
				if(line.indexOf("<td class=\"SearchResultTotal middle\">") != -1){
					offset = line.indexOf(">");
					offset2 = line.indexOf("件", offset);
					fig = line.substring(offset+1, offset2);
					break;
				}
			}
			int t_cnt = 0;
			try{
				t_cnt = Integer.parseInt(fig);
			}catch(NumberFormatException nfe){
				//文字列－数値変換エラー処理
				sb.append(nfe+"・");
				return;
			}

			t_cnt = t_cnt / 20;
			if(t_cnt % 20 != 0){
				t_cnt++;
			}

			Thread[] thread = new Thread[t_cnt];
			try{
				for(int i = 0; i < thread.length; i++){
					thread[i] = new Thread(
							new SYOGKCsubInfogetter(
									new URL(url.toString() + (i+1)), this.map, this.sb));
					thread[i].start();
				}
			}catch(MalformedURLException murle){
				//URL変換エラー処理
				sb.append(murle+"・");
				return;
			}
			try{
				for(int i = 0; i < thread.length; i++){
					thread[i].join();
				}
			}catch(InterruptedException ie){
				//スレッド待機エラー処理
				sb.append(ie+"・");
				return;
			}
		}catch(Exception e){
			sb.append(this.getClass().getName() + "・");
		}
	}
}