import java.awt.event.ActionEvent;
import java.util.SortedMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.AbstractAction;
import javax.swing.DefaultListModel;
import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.JTextField;


public class SearchActionListener extends AbstractAction {
	private JList list;
	private SortedMap<String, Book> map;
	private JComboBox combo;
	private JTextField searchField;
	public SearchActionListener(JTextField tf, JList list, SortedMap<String, Book> map, JComboBox combo){
		this.searchField = tf;
		this.list = list;
		this.map = map;
		this.combo = combo;
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		String target = searchField.getText();
		if(target.equals("")){
			return;
		}
		target = target.replaceAll("\\.", "\\.")
						.replaceAll("\\(", "\\(")
						.replaceAll("\\)", "\\)")
						.replaceAll("\\[", "\\[")
						.replaceAll("\\]", "\\]")
						.replaceAll("\\^", "\\^")
						.replaceAll("\\$", "\\$")
						.replaceAll("\\\\", "\\\\");
		Pattern pattern = Pattern.compile(".*"+target+".*", Pattern.UNICODE_CASE |Pattern.CASE_INSENSITIVE);
		String command = (String)combo.getSelectedItem();
		DefaultListModel model = (DefaultListModel)list.getModel();
		model.clear();

		if(command.equals((String)combo.getItemAt(0))){
			for(String temp : map.keySet()){
				Matcher matcher = pattern.matcher(temp);
				if(matcher.matches()){
					model.addElement(temp);
				}
			}
		}
		else if(command.equals((String)combo.getItemAt(1))){
			for(String temp : map.keySet()){
				Book book = map.get(temp);
				Matcher matcher = pattern.matcher(book.getAuthor());
				if(matcher.matches()){
					model.addElement(temp);
				}
			}
		}
		else if(command.equals((String)combo.getItemAt(2))){
			for(String temp : map.keySet()){
				Book book = map.get(temp);
				Matcher matcher = pattern.matcher(book.getPublisher());
				if(matcher.matches()){
					model.addElement(temp);
				}
			}
		}
		else if(command.equals((String)combo.getItemAt(3))){
			for(String temp : map.keySet()){
				Book book = map.get(temp);
				Matcher matcher = pattern.matcher(book.getLabel());
				if(matcher.matches()){
					model.addElement(temp);
				}
			}
		}
	}

}
